#%RAML 1.0
version: v1
title: Send FB Message API
description: API for sending free FB to FB

types:
  fbRequest: !include Datatype/fbRequest.raml
  fbResponseValid: !include Datatype/fbResponseValid.raml
  fbResponseError: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/api-response-datatype-api/1.0.0/api-response-datatype-api.raml

traits:
  headerTrait: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/header-securable/1.0.0/header-securable.raml
/fb:
  post:
    is:
      - headerTrait
    description: Send request Free FB message to Facebook
    headers:
      correlationid:
        type: string
        description: Tranasction ID that is passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
      shared_key: 
        type: string
        description: Shared key given by FB

    queryParameters:
      hmac: 
        type: string
        description: HMAC256 encrypted form of timestamp+ carrier_id
        example: a5483f5234403a4f610775a0213fd49f0a14a4e29c8161782e56d41b1db221df

    body:
      application/json:
        type: fbRequest
        example:
          !include Examples/requestExample.json
    responses:
      200:
        body:
          application/json:
            type: fbResponseValid
            example: !include Examples/responseValidExample.json
      400:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError400Example.json
      404:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError404Example.json 
      405:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError405Example.json
      406:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError406Example.json
      415:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError415Example.json
      501:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError501Example.json        
      500:
        body:
          application/json:
            type: fbResponseError
            example: !include Examples/responseError500Example.json
              
      